//
// Created by mizushima on 2012/10/25.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import "MonoidTestCase.h"
#import "Monoid.h"
#import "Monoids.h"


@implementation MonoidTestCase 

- (void)testIntMonoid {
    NSObject<Monoid>* m = [Monoids intMonoid];
    
    NSObject* result = [m plus:@1 by:@2];

    STAssertEqualObjects(result, @3, nil);
    
    result = [m plus:@2 by:@1];

    STAssertEqualObjects(result, @3, nil);

    STAssertEqualObjects(m.zero, @0, nil);
}

- (void)testDoubleMonoid {
    NSObject<Monoid>* m = [Monoids doubleMonoid];
    
    NSObject* result = [m plus:@1.5 by:@2.5];
    
    STAssertEqualObjects(result, @4.0, nil);
    
    result = [m plus:@1.5 by:@2.5];
    
    STAssertEqualObjects(result, @4.0, nil);
    
    STAssertEqualObjects(m.zero, @0.0, nil);
}

- (void)testStringMonoid {

    NSObject<Monoid>* m = [Monoids stringMonoid];
    
    NSObject* result = [m plus:@"a" by:@"b"];
    
    STAssertEqualObjects(result, @"ab", nil);
    
    result = [m plus:@"b" by:@"a"];
    
    STAssertEqualObjects(result, @"ba", nil);
    
    STAssertEqualObjects(m.zero, @"", nil);

}



@end